;NSIS installer for Me and My Shadow (meandmyshadow.sf.net)

;--------------------------------
;Include

  !include "MUI2.nsh"

;--------------------------------
;Define everything

  Name "Me and My Shadow"
  OutFile "MeAndMyShadowInstaller.exe"
  InstallDir "$PROGRAMFILES\Me and My Shadow"
  RequestExecutionLevel admin

  Var StartMenuFolder

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "banner.bmp"
  !define MUI_ABORTWARNING

  ;Create Installer
  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_STARTMENU "Application" $StartMenuFolder
  !insertmacro MUI_PAGE_INSTFILES
  
  ;Create Uninstaller
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH
  
  ;Languages
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer section

Section

  ;Add all files
  SetOutPath "$INSTDIR"
  File License
  File meandmyshadow.exe
  File *.dll
  File /r data
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"
  
  ;Add an entry to Add/Remove
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MeAndMyShadow" \
                   "DisplayName" "Me and My Shadow"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MeAndMyShadow" \
                   "UninstallString" "$\"$INSTDIR\uninstall.exe$\""
  
  ;Create shortcuts
  SetOutPath "$INSTDIR"
  !insertmacro MUI_STARTMENU_WRITE_BEGIN "Application"
    CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
    CreateShortCut  "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
    CreateShortCut  "$SMPROGRAMS\$StartMenuFolder\Me and My Shadow.lnk" "$INSTDIR\meandmyshadow.exe"
  !insertmacro MUI_STARTMENU_WRITE_END

SectionEnd
 
;--------------------------------
;Uninstaller section

Section "Uninstall"

  ;Remove every file
  RMDir /r "$INSTDIR"
  
  ;Remove entry from Add/Remove
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MeAndMyShadow"
  
  ;Remove shortcuts
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $StartMenuFolder
  Delete "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk"
  Delete "$SMPROGRAMS\$StartMenuFolder\Me and My Shadow.lnk"
  RMDir "$SMPROGRAMS\$StartMenuFolder"

SectionEnd